package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.AmsDispatchSaleOrderMapper;
import com.steerinfo.dil.model.AmsDispatchSaleOrder;
import com.steerinfo.dil.service.IAmsDispatchSaleOrderService;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * AmsDispatchSaleOrder服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-10 03:59
 * 类描述
 * 修订历史：
 * 日期：2021-09-10
 * 作者：generator
 * 参考：
 * 描述：AmsDispatchSaleOrder服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amsDispatchSaleOrderService")
public class AmsDispatchSaleOrderServiceImpl extends BaseServiceImpl<AmsDispatchSaleOrder, BigDecimal> implements IAmsDispatchSaleOrderService {

    @Autowired
    private AmsDispatchSaleOrderMapper amsDispatchSaleOrderMapper;

    @Override
    protected IBaseMapper<AmsDispatchSaleOrder, BigDecimal> getMapper() {
        return amsDispatchSaleOrderMapper;
    }

    public List<Map<String, Object>> getOpenDispatchSaleOrder(Map<String, Object> mapValue) {
        return amsDispatchSaleOrderMapper.getOpenDispatchSaleOrder(mapValue);
    }

    /**
     * 查询最大id
     * @return
     */
    @Override
    public BigDecimal selectMaxId() {

        return amsDispatchSaleOrderMapper.selectOtherId();
    }

    public int insert(AmsDispatchSaleOrder ad) {
        ad.setDispatchTime(new Date());
        ad.setInsertTime(new Date());
        ad.setInsertUsername("admin");
        return amsDispatchSaleOrderMapper.insertSelective(ad);
    }
}
