package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.AmsSaleOrderMaterialMapper;
import com.steerinfo.dil.model.AmsSaleOrderMaterial;
import com.steerinfo.dil.service.IAmsSaleOrderMaterialService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * AmsSaleOrderMaterial服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-09-06 07:10
 * 类描述
 * 修订历史：
 * 日期：2021-09-06
 * 作者：generator
 * 参考：
 * 描述：AmsSaleOrderMaterial服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amsSaleOrderMaterialService")
public class AmsSaleOrderMaterialServiceImpl implements IAmsSaleOrderMaterialService {

    @Autowired
    private AmsSaleOrderMaterialMapper amsSaleOrderMaterialMapper;

    @Override
    public int addAmsSaleOrderMaterial(AmsSaleOrderMaterial amsSaleOrderMaterial) {
        long id;
        if(amsSaleOrderMaterialMapper.selectMaxId()==null){
            id = 1;
        }else {
            id = amsSaleOrderMaterialMapper.selectMaxId().longValue()+1;
        }
        //生成主键id
        amsSaleOrderMaterial.setSaleOrderMaterialId(new BigDecimal(id));
        //常规字段
        amsSaleOrderMaterial.setInsertUsername("admin");
        amsSaleOrderMaterial.setInsertTime(new Date());
        amsSaleOrderMaterial.setUpdateUsername("admin");
        amsSaleOrderMaterial.setUpdateTime(new Date());
        amsSaleOrderMaterial.setInsertUpdateRemark("无");
        amsSaleOrderMaterial.setDeleted(new BigDecimal(0));
        return amsSaleOrderMaterialMapper.insert(amsSaleOrderMaterial);
    }

    @Override
    public List<Map<String, Object>> selectBySaleOrderMaterialId(BigDecimal saleOrderMaterialId) {
        return amsSaleOrderMaterialMapper.selectBySaleOrderMaterialId(saleOrderMaterialId);
    }

    @Override
    public int updateAmsSaleOrderMaterial(AmsSaleOrderMaterial amsSaleOrderMaterial) {
        amsSaleOrderMaterial.setUpdateTime(new Date());
        return amsSaleOrderMaterialMapper.updateByPrimaryKeySelective(amsSaleOrderMaterial);
    }

    @Override
    public int deleteAmsSaleOrderMaterialBySaleOrderMaterialId(BigDecimal saleOrderMaterialId) {
        AmsSaleOrderMaterial amsSaleOrderMaterial = amsSaleOrderMaterialMapper.selectByPrimaryKey(saleOrderMaterialId);
        amsSaleOrderMaterial.setDeleted(new BigDecimal(1));
        return amsSaleOrderMaterialMapper.updateByPrimaryKey(amsSaleOrderMaterial);
    }

    @Override
    public String getAddress(BigDecimal saleOrderMaterialId) {
        return amsSaleOrderMaterialMapper.getAddress(saleOrderMaterialId);
    }

    @Override
    public int updateAddress(AmsSaleOrderMaterial amsSaleOrderMaterial) {
        BigDecimal saleOrderMaterialId = amsSaleOrderMaterial.getSaleOrderMaterialId();
        AmsSaleOrderMaterial amsSaleOrderMaterial1 = amsSaleOrderMaterialMapper.selectByPrimaryKey(saleOrderMaterialId);
        String saleShippingAddress = amsSaleOrderMaterial1.getSaleShippingAddress();
        long id;
        if(amsSaleOrderMaterialMapper.selectMaxId()==null){
            id = 1;
        }else {
            id = amsSaleOrderMaterialMapper.selectMaxId().longValue()+1;
        }
        //生成主键id
        amsSaleOrderMaterial1.setSaleOrderMaterialId(new BigDecimal(id));
        amsSaleOrderMaterial1.setSaleShippingAddress(amsSaleOrderMaterial.getSaleShippingAddress());
        //新增修改了地址的数据
        System.out.println("amsSaleOrderMaterial1 = "+amsSaleOrderMaterial1);
        amsSaleOrderMaterialMapper.insert(amsSaleOrderMaterial1);
        //地址回插
        amsSaleOrderMaterial.setSaleShippingAddress(saleShippingAddress);
        amsSaleOrderMaterial.setUpdated(new BigDecimal(1));
        return amsSaleOrderMaterialMapper.updateByPrimaryKeySelective(amsSaleOrderMaterial);
    }
    public List<Map<String, Object>> getSaleMaterial(Map<String, Object> mapValue) {
        return amsSaleOrderMaterialMapper.getSaleMaterial(mapValue);
    }


    public Integer selectById(BigDecimal saleOrderMaterialId) {
        return amsSaleOrderMaterialMapper.selectById(saleOrderMaterialId);
    }

    public Integer selectByCxh(Map<String, Object> m) {
        return amsSaleOrderMaterialMapper.selectByCxh(m);
    }
}
